<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_TipoMovimientoMast.xml */
/* Generado: 2020-08-18 04:21:24 */

/* Mantenimiento de los registros de la tabla ALM_TipoMovimientoMast */
abstract class BaseALM_TipoMovimientoMastDP extends ALM_TipoMovimientoMastBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_TipoMovimientoMastBN ) */
    public function __construct( ALM_TipoMovimientoMastBN $o_ALM_TipoMovimientoMastBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_TipoMovimientoMastBN ) )
        {
            $this->setByBN( $o_ALM_TipoMovimientoMastBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_TipoMovimientoMastBN */
    public function setByBN( ALM_TipoMovimientoMastBN $o_ALM_TipoMovimientoMastBN )
    {
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getIdTransaccion() ) )
        {
            $this->setIdTransaccion( $o_ALM_TipoMovimientoMastBN->getIdTransaccion() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getDescripcionLocal() ) )
        {
            $this->setDescripcionLocal( $o_ALM_TipoMovimientoMastBN->getDescripcionLocal() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getDescripcionIngles() ) )
        {
            $this->setDescripcionIngles( $o_ALM_TipoMovimientoMastBN->getDescripcionIngles() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getIngresoEgresoFlag() ) )
        {
            $this->setIngresoEgresoFlag( $o_ALM_TipoMovimientoMastBN->getIngresoEgresoFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getTipoDocumentoGenerado() ) )
        {
            $this->setTipoDocumentoGenerado( $o_ALM_TipoMovimientoMastBN->getTipoDocumentoGenerado() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getTipoDocumentoValidado() ) )
        {
            $this->setTipoDocumentoValidado( $o_ALM_TipoMovimientoMastBN->getTipoDocumentoValidado() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getTransacciondelSistemaFlag() ) )
        {
            $this->setTransacciondelSistemaFlag( $o_ALM_TipoMovimientoMastBN->getTransacciondelSistemaFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getNumeracionAutomaticaFlag() ) )
        {
            $this->setNumeracionAutomaticaFlag( $o_ALM_TipoMovimientoMastBN->getNumeracionAutomaticaFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getCampoReferenciaFlag() ) )
        {
            $this->setCampoReferenciaFlag( $o_ALM_TipoMovimientoMastBN->getCampoReferenciaFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getGenerarVoucherFlag() ) )
        {
            $this->setGenerarVoucherFlag( $o_ALM_TipoMovimientoMastBN->getGenerarVoucherFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getAjusteInventarioFlag() ) )
        {
            $this->setAjusteInventarioFlag( $o_ALM_TipoMovimientoMastBN->getAjusteInventarioFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getAjusteInventarioCuenta() ) )
        {
            $this->setAjusteInventarioCuenta( $o_ALM_TipoMovimientoMastBN->getAjusteInventarioCuenta() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getTransaccionVentaFlag() ) )
        {
            $this->setTransaccionVentaFlag( $o_ALM_TipoMovimientoMastBN->getTransaccionVentaFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getDireccionDestinoFlag() ) )
        {
            $this->setDireccionDestinoFlag( $o_ALM_TipoMovimientoMastBN->getDireccionDestinoFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getValorizacionManualFlag() ) )
        {
            $this->setValorizacionManualFlag( $o_ALM_TipoMovimientoMastBN->getValorizacionManualFlag() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getClasificacion() ) )
        {
            $this->setClasificacion( $o_ALM_TipoMovimientoMastBN->getClasificacion() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getEstado() ) )
        {
            $this->setEstado( $o_ALM_TipoMovimientoMastBN->getEstado() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_TipoMovimientoMastBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_TipoMovimientoMastBN->getFechaModificacion() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_TipoMovimientoMastBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_TipoMovimientoMastBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_TipoMovimientoMastBN->getFechaCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_TipoMovimientoMastFN = new ALM_TipoMovimientoMastFN();
        $o_ALM_TipoMovimientoMastBN = $o_ALM_TipoMovimientoMastFN->selectByPk( $this->getIdTransaccion() );
        if ( is_null( $o_ALM_TipoMovimientoMastBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_TipoMovimientoMast ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdTransaccion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTransaccion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTransaccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionLocal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionLocal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionLocal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionIngles() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionIngles";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionIngles()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIngresoEgresoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IngresoEgresoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIngresoEgresoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumentoGenerado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoDocumentoGenerado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoDocumentoGenerado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumentoValidado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoDocumentoValidado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoDocumentoValidado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransacciondelSistemaFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TransacciondelSistemaFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTransacciondelSistemaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeracionAutomaticaFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeracionAutomaticaFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeracionAutomaticaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCampoReferenciaFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CampoReferenciaFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCampoReferenciaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getGenerarVoucherFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."GenerarVoucherFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getGenerarVoucherFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAjusteInventarioFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."AjusteInventarioFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getAjusteInventarioFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAjusteInventarioCuenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."AjusteInventarioCuenta";
                $s_SQLQuery2 .= $s_Separator."'".$this->getAjusteInventarioCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransaccionVentaFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TransaccionVentaFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTransaccionVentaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccionDestinoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DireccionDestinoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDireccionDestinoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValorizacionManualFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ValorizacionManualFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getValorizacionManualFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClasificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Clasificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getClasificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_TipoMovimientoMast SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcionLocal() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionLocal = '".$this->getDescripcionLocal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionIngles() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionIngles = '".$this->getDescripcionIngles()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIngresoEgresoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."IngresoEgresoFlag = '".$this->getIngresoEgresoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumentoGenerado() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoDocumentoGenerado = '".$this->getTipoDocumentoGenerado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumentoValidado() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoDocumentoValidado = '".$this->getTipoDocumentoValidado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransacciondelSistemaFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."TransacciondelSistemaFlag = '".$this->getTransacciondelSistemaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeracionAutomaticaFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeracionAutomaticaFlag = '".$this->getNumeracionAutomaticaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCampoReferenciaFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."CampoReferenciaFlag = '".$this->getCampoReferenciaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getGenerarVoucherFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."GenerarVoucherFlag = '".$this->getGenerarVoucherFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAjusteInventarioFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."AjusteInventarioFlag = '".$this->getAjusteInventarioFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAjusteInventarioCuenta() ) )
            {
                $s_SQLQuery .= $s_Separator."AjusteInventarioCuenta = '".$this->getAjusteInventarioCuenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTransaccionVentaFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."TransaccionVentaFlag = '".$this->getTransaccionVentaFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccionDestinoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."DireccionDestinoFlag = '".$this->getDireccionDestinoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getValorizacionManualFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."ValorizacionManualFlag = '".$this->getValorizacionManualFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClasificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."Clasificacion = '".$this->getClasificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdTransaccion = '".$this->getIdTransaccion()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_TipoMovimientoMast WHERE  IdTransaccion = '".$this->getIdTransaccion()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>